﻿Public Class Form2

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Me.Close()
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim nendo As Integer = Form1.isValidAsInteger(TbNendo.Text)
        Dim i As Integer
        Dim strSQL As String

        Dim idx As Integer = Form1.ds0.Tables.IndexOf("kaikeinendo")
        Debug.Print("index = " & idx.ToString)
        Try
            '指定された会計年度のデータベースが既に存在するかどうかを調べる
            If idx >= 0 Then
                For i = 0 To Form1.ds0.Tables("kaikeinendo").Rows.Count - 1
                    If Form1.ds0.Tables("kaikeinendo").Rows(i).Item("nendo") = nendo Then
                        MsgBox("指定された会計年度のデータベースは既に存在します")
                        Exit Sub
                    End If
                Next
            Else
                'テーブルkaikeinendoを作る(初回起動後用）
                strSQL = "create table kaikeinendo(" _
                        & "nendo  INT(4) not null ," _
                        & "kisyu DATE not null, " _
                        & "kimatsu DATE not null, " _
                        & "nameDB CHAR(10) not null, " _
                        & "kessan1 DATE default null, " _
                        & "kessan2 DATE default null, " _
                        & "kessan3 DATE default null, " _
                        & "PRIMARY KEY (nendo) " _
                        & ")CHARSET=sjis; "
                If NonQueryCommand(Form1.conStr, strSQL) = False Then
                    Debug.Print("SQL: " & strSQL)
                End If
                '初回起動なのでlastusedテーブルも作る
                strSQL = "create table lastused(" _
                        & "id INT(2) not null auto_increment ," _
                        & "nendo  INT(4) not null, " _
                        & "nameDB CHAR(10) not null, " _
                        & "PRIMARY KEY (id) " _
                        & ")CHARSET=sjis; "
                If NonQueryCommand(Form1.conStr, strSQL) = False Then
                    Debug.Print("SQL: " & strSQL)
                End If
                'lastusedの内容を初期化する
                strSQL = "INSERT INTO lastused (nendo, nameDB) values('" _
                    & TbNendo.Text & "', '" & TbNameDB.Text & "');"
                If NonQueryCommand(Form1.conStr, strSQL) = False Then
                    Debug.Print("SQL: " & strSQL)
                End If
            End If
            
            If (TbNendo.TextLength = 4) And (nendo > 2013) Then
                'テーブル(kaikeinendo)にnendoとnameDBを追記する
                strSQL = "insert into kaikeinendo values('"
                strSQL &= TbNendo.Text & "', '" & TbNendo.Text & "-01-01', '"
                strSQL &= TbNendo.Text & "-12-31', '"
                strSQL &= TbNameDB.Text & "', null, null, null);"
                If NonQueryCommand(Form1.conStr, strSQL) = False Then
                    Debug.Print("SQL: " & strSQL)
                End If
                Debug.Print("SQL: " & strSQL)
                '更新内容を反映するためにテーブルを読直す
                If idx >= 0 Then
                    Dim table As DataTable = Form1.ds0.Tables("kaikeinendo")
                    table.Clear()
                End If
                DataBaseModule.FillTable(Form1.ds0, "kaikeinendo", Form1.conStr)

                'データベースを作成する
                strSQL = "CREATE DATABASE IF NOT EXISTS " & TbNameDB.Text & " DEFAULT CHARACTER SET SJIS;"
                If NonQueryCommand(Form1.conStr, strSQL) = False Then
                    Debug.Print("SQL: " & strSQL)
                End If
                '作成したデータベースにコネクションストリングをセットする
                Form1.makeConFY(TbNameDB.Text)
                '現金出納帳テーブルを3つ作成する
                strSQL = "create table genkin1 ("
                strSQL &= "id INT(5) NOT NULL auto_increment,"
                strSQL &= "hizuke DATE not null,"
                strSQL &= "code	CHAR(4) not null,"
                strSQL &= "syunyu INT(8),"
                strSQL &= "shisyutsu INT(8),"
                strSQL &= "zandaka INT(8) not null,"
                strSQL &= "tekiyo TEXT not null,"
                strSQL &= "PRIMARY KEY(id));"
                If NonQueryCommand(Form1.conFY, strSQL) = False Then
                    Debug.Print("SQL: " & strSQL)
                End If
                strSQL = "create table genkin2 ("
                strSQL &= "id INT(5) NOT NULL auto_increment,"
                strSQL &= "hizuke DATE not null,"
                strSQL &= "code	CHAR(4) not null,"
                strSQL &= "syunyu INT(8),"
                strSQL &= "shisyutsu INT(8),"
                strSQL &= "zandaka INT(8) not null,"
                strSQL &= "tekiyo TEXT not null,"
                strSQL &= "PRIMARY KEY(id));"
                If NonQueryCommand(Form1.conFY, strSQL) = False Then
                    Debug.Print("SQL: " & strSQL)
                End If
                strSQL = "create table genkin3 ("
                strSQL &= "id INT(5) NOT NULL auto_increment,"
                strSQL &= "hizuke DATE not null,"
                strSQL &= "code	CHAR(4) not null,"
                strSQL &= "syunyu INT(8),"
                strSQL &= "shisyutsu INT(8),"
                strSQL &= "zandaka INT(8) not null,"
                strSQL &= "tekiyo TEXT not null,"
                strSQL &= "PRIMARY KEY(id));"
                If NonQueryCommand(Form1.conFY, strSQL) = False Then
                    Debug.Print("SQL: " & strSQL)
                End If
                '仕訳帳テーブルを3つ作成する
                strSQL = "create table shiwake1 ("
                strSQL &= "id INT(5) NOT NULL auto_increment,"
                strSQL &= "yyyymmdd DATE not null,"
                strSQL &= "DrCode CHAR(4) default null,"
                strSQL &= "DrAmount INT(8) default null,"
                strSQL &= "CrCode CHAR(4) default null,"
                strSQL &= "CrAmount INT(8) default null,"
                strSQL &= "remarks TEXT default null,"
                strSQL &= "PRIMARY KEY(id));"
                If NonQueryCommand(Form1.conFY, strSQL) = False Then
                    Debug.Print("SQL: " & strSQL)
                End If
                strSQL = "create table shiwake2 ("
                strSQL &= "id INT(5) NOT NULL auto_increment,"
                strSQL &= "yyyymmdd DATE not null,"
                strSQL &= "DrCode CHAR(4) default null,"
                strSQL &= "DrAmount INT(8) default null,"
                strSQL &= "CrCode CHAR(4) default null,"
                strSQL &= "CrAmount INT(8) default null,"
                strSQL &= "remarks TEXT default null,"
                strSQL &= "PRIMARY KEY(id));"
                If NonQueryCommand(Form1.conFY, strSQL) = False Then
                    Debug.Print("SQL: " & strSQL)
                End If
                strSQL = "create table shiwake3 ("
                strSQL &= "id INT(5) NOT NULL auto_increment,"
                strSQL &= "yyyymmdd DATE not null,"
                strSQL &= "DrCode CHAR(4) default null,"
                strSQL &= "DrAmount INT(8) default null,"
                strSQL &= "CrCode CHAR(4) default null,"
                strSQL &= "CrAmount INT(8) default null,"
                strSQL &= "remarks TEXT default null,"
                strSQL &= "PRIMARY KEY(id));"
                If NonQueryCommand(Form1.conFY, strSQL) = False Then
                    Debug.Print("SQL: " & strSQL)
                End If
                '総勘定元帳テーブルを3つ作成する
                strSQL = "create table motocho1 ("
                strSQL &= "serial INT(5) NOT NULL auto_increment,"
                strSQL &= "kamoku CHAR(4) default null,"
                strSQL &= "yyyymmdd DATE not null,"
                strSQL &= "tekiyo CHAR(4) not null,"
                strSQL &= "id INT(5) not null,"
                strSQL &= "subid INT(5) default null,"
                strSQL &= "DrAmount INT(8) default null,"
                strSQL &= "CrAmount INT(8) default null,"
                strSQL &= "DorC CHAR(1) not null,"
                strSQL &= "zandaka INT(8) not null,"
                strSQL &= "PRIMARY KEY(serial));"
                If NonQueryCommand(Form1.conFY, strSQL) = False Then
                    Debug.Print("SQL: " & strSQL)
                End If
                strSQL = "create table motocho2 ("
                strSQL &= "serial INT(5) NOT NULL auto_increment,"
                strSQL &= "kamoku CHAR(4) default null,"
                strSQL &= "yyyymmdd DATE not null,"
                strSQL &= "tekiyo CHAR(4) not null,"
                strSQL &= "id INT(5) not null,"
                strSQL &= "subid INT(5) default null,"
                strSQL &= "DrAmount INT(8) default null,"
                strSQL &= "CrAmount INT(8) default null,"
                strSQL &= "DorC CHAR(1) not null,"
                strSQL &= "zandaka INT(8) not null,"
                strSQL &= "PRIMARY KEY(serial));"
                If NonQueryCommand(Form1.conFY, strSQL) = False Then
                    Debug.Print("SQL: " & strSQL)
                End If
                strSQL = "create table motocho3 ("
                strSQL &= "serial INT(5) NOT NULL auto_increment,"
                strSQL &= "kamoku CHAR(4) default null,"
                strSQL &= "yyyymmdd DATE not null,"
                strSQL &= "tekiyo CHAR(4) not null,"
                strSQL &= "id INT(5) not null,"
                strSQL &= "subid INT(5) default null,"
                strSQL &= "DrAmount INT(8) default null,"
                strSQL &= "CrAmount INT(8) default null,"
                strSQL &= "DorC CHAR(1) not null,"
                strSQL &= "zandaka INT(8) not null,"
                strSQL &= "PRIMARY KEY(serial));"
                If NonQueryCommand(Form1.conFY, strSQL) = False Then
                    Debug.Print("SQL: " & strSQL)
                End If
                MsgBox("データベース(" & TbNameDB.Text & ")を作成し空のテーブルを作成しました")
                Me.Close()
            Else
                MsgBox("入力内容が不適切です")
            End If

        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub
End Class